
'A little code to play with color and text justify into a single cell or in a range of QSTRINGGRID

'To use the range option and be able to justify the text, I chose not to write directly to the cells
'but using other ways:
'- using TextOut method
'- using DrawText WINAPI call

'To edit a cell, you must write into edit control in the upper left (or through the code)

'You could select a range and change text color, background color and text justify in one step.
'If you use DrawText, you could play with the following format flags and see what happens..

'Added open & save
'Added copy & paste custom clip format

'13/06/2011
'New range selection. Used a QMEMORYSTREAM obj  => and a WM_LBUTTONUP event in WndProc. <=  We don't need it
'added range copy & paste. You can copy only the same number of cells _
'of the initial selected range but in the order you want. I.e. four cells in a square selection _
'could be copied in a 4 cells vertical / horizontal range.
'if someone writes a code improvements, please let me know.

'22/06/11
'added 12 level UNDO/REDO


$TYPECHECK ON
$INCLUDE "RapidQ2.inc"
$INCLUDE "SysUtils.inc"
'$APPTYPE GUI

CONST MK_LBUTTON = &H1
CONST MK_MBUTTON = &H10
CONST MK_RBUTTON = &H2

'DrawText() Format Flags
Public CONST DT_TOP = &H0
Public CONST DT_LEFT = &H0
Public CONST DT_CENTER = &H1
Public CONST DT_RIGHT = &H2
Public CONST DT_VCENTER = &H4
Public CONST DT_BOTTOM = &H8
Public CONST DT_WORDBREAK = &H10
Public CONST DT_SINGLELINE = &H20
Public CONST DT_EXPANDTABS = &H40
Public CONST DT_TABSTOP = &H80
Public CONST DT_NOCLIP = &H100
Public CONST DT_EXTERNALLEADING = &H200
Public CONST DT_CALCRECT = &H400
Public CONST DT_NOPREFIX = &H800
Public CONST DT_INTERNAL = &H1000

'global memory flags
CONST GMEM_FIXED = &H0
CONST GMEM_INVALID_HANDLE = &H8000
CONST GMEM_LOCKCOUNT = &HFF
CONST GMEM_MODIFY = &H80
CONST GMEM_MOVEABLE = &H2
CONST GMEM_NOCOMPACT = &H10
CONST GMEM_NODISCARD = &H20
CONST GMEM_NOT_BANKED = &H1000
CONST GMEM_NOTIFY = &H4000
CONST GMEM_SHARE = &H2000
CONST GMEM_VALID_FLAGS = &H7F72
CONST GMEM_ZEROINIT = &H40

'Heap memory flags
CONST HEAP_ZERO_MEMORY = &H8
CONST HEAP_NO_SERIALIZE = &H1

CONST NUM_LEVEL_UNDO = 11

DECLARE FUNCTION SetTextColor LIB "gdi32" ALIAS "SetTextColor"(ByVal hdc AS LONG , ByVal crColor AS LONG) AS LONG
DECLARE FUNCTION TextOut LIB "gdi32" ALIAS "TextOutA"(ByVal hdc AS LONG , ByVal x AS LONG , ByVal y AS LONG , ByVal lpString AS STRING , ByVal nCount AS LONG) AS LONG
DECLARE FUNCTION DrawText LIB "user32" ALIAS "DrawTextA"(ByVal hdc AS LONG , ByVal lpStr AS STRING , ByVal nCount AS LONG , lpRect AS RECT , ByVal wFormat AS LONG) AS LONG

DECLARE FUNCTION RegisterClipboardFormat LIB "user32" ALIAS "RegisterClipboardFormatA"(ByVal lpString AS STRING) AS LONG
DECLARE FUNCTION GlobalAlloc LIB "kernel32" ALIAS "GlobalAlloc"(ByVal wFlags AS LONG , ByVal dwBytes AS LONG) AS LONG
DECLARE FUNCTION GlobalFree LIB "kernel32" ALIAS "GlobalFree"(ByVal hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalLock LIB "kernel32" ALIAS "GlobalLock"(ByVal hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalUnlock LIB "kernel32" ALIAS "GlobalUnlock"(ByVal hMem AS LONG) AS LONG

'DECLARE FUNCTION HeapCreate LIB "kernel32" ALIAS "HeapCreate"(ByVal flOptions AS LONG , ByVal dwInitialSize AS LONG , ByVal dwMaximumSize AS LONG) AS LONG
'DECLARE FUNCTION HeapDestroy LIB "kernel32" ALIAS "HeapDestroy"(ByVal hHeap AS LONG) AS LONG
'DECLARE FUNCTION HeapAlloc LIB "kernel32" ALIAS "HeapAlloc"(ByVal hHeap AS LONG , ByVal dwFlags AS LONG , ByVal dwBytes AS LONG) AS LONG
'DECLARE FUNCTION HeapReAlloc LIB "kernel32" ALIAS "HeapReAlloc"(ByVal hHeap AS LONG , ByVal dwFlags AS LONG , lpMem AS LONG , ByVal dwBytes AS LONG) AS LONG
'DECLARE FUNCTION HeapFree LIB "kernel32" ALIAS "HeapFree"(ByVal hHeap AS LONG , ByVal dwFlags AS LONG , lpMem AS LONG) AS LONG
'DECLARE FUNCTION HeapSize LIB "kernel32" ALIAS "HeapSize"(ByVal hHeap AS LONG , ByVal dwFlags AS LONG , lpMem AS LONG) AS LONG
'DECLARE FUNCTION GetProcessHeap LIB "kernel32" ALIAS "GetProcessHeap"() AS LONG

DECLARE FUNCTION StringGridWndProc(hWnd AS LONG , uMsg AS LONG , wParam AS LONG , lParam AS LONG) AS LONG
DECLARE SUB Initialize
DECLARE SUB Quit
DECLARE SUB GridOnSelectCell(Col% , Row% , CanSelect% , Sender AS QSTRINGGRID)
DECLARE SUB GridOnDrawcell(Col% , Row% , State% , Rect AS QRECT , Sender AS QSTRINGGRID)
DECLARE SUB MnuFColor_Click
DECLARE SUB MnuBColor_Click
DECLARE SUB MnuLSet_Click
DECLARE SUB MnuCSet_Click
DECLARE SUB MnuRSet_Click
DECLARE SUB MnuEdit_Click
DECLARE SUB MnuCopy_Click
DECLARE SUB MnuPaste_Click
DECLARE SUB MnuSwpCol_Click
DECLARE SUB CEditKeyPress(Key AS BYTE)
DECLARE SUB GridKeyPress(Key AS BYTE)
DECLARE SUB GridKeyDown(Key AS WORD , Shift AS INTEGER)
DECLARE SUB Set_format(wform AS INTEGER)
DECLARE SUB SaveItemOnClick
DECLARE SUB OpenItemOnClick
DECLARE SUB AboutItemOnClick
DECLARE SUB RangeSel
DECLARE SUB MnuUndo_Click
DECLARE SUB MnuRedo_Click
DECLARE SUB AddToUndo(cs% , rs% , ce% , re%)
DECLARE SUB AddToRedo(cs% , rs% , ce% , re%)
DECLARE SUB StringOut(x1% , y1% , text$ , col& , wrect AS RECT , format&)

CREATE MyFont AS QFONT
   Name = "Arial"
   Size = 12
   Color = &HC0FFFF
END CREATE

CREATE Form AS QFORM
   Caption = "Range Select"
   Width = SCREEN.Width * .75
   Height = SCREEN.Height * .75
   Center
   OnShow = Initialize
   OnClose = Quit

   CREATE MainMenu AS QMAINMENU
      CREATE FileItem AS QMENUITEM
         Caption = "&File"
         CREATE Open AS QMENUITEM
            Caption = "&Open"
            OnClick = OpenItemOnClick
            ShortCut = "^o"
         END CREATE
         CREATE Save AS QMENUITEM
            Caption = "&Save"
            OnClick = SaveItemOnClick
            ShortCut = "^s"
         END CREATE
         CREATE CloseItem AS QMENUITEM
            Caption = "&Exit"
            OnClick = Quit
            ShortCut = "^x"
         END CREATE
      END CREATE
      CREATE EditItem AS QMENUITEM
         Caption = "Edit"
         CREATE MnuEdit AS QMENUITEM
            Caption = "Edit Current Cell"
            OnClick = MnuEdit_Click
            ShortCut = "Ctrl+E"
         END CREATE
         CREATE line1 AS QMENUITEM
            Caption = "-"
         END CREATE
         CREATE MnuCopy AS QMENUITEM
            Caption = "Copy"
            OnClick = MnuCopy_Click
            ShortCut = "Ctrl+C"
         END CREATE
         CREATE MnuPaste AS QMENUITEM
            Caption = "Paste"
            OnClick = MnuPaste_Click
            ShortCut = "Ctrl+V"
         END CREATE
         CREATE line2 AS QMENUITEM
            Caption = "-"
         END CREATE
         CREATE MnuFColor AS QMENUITEM
            Caption = "Foreground Color"
            OnClick = MnuFColor_Click
            ShortCut = "Ctrl+F"
         END CREATE
         CREATE MnuBColor AS QMENUITEM
            Caption = "Backgroundcolor"
            OnClick = MnuBColor_Click
            ShortCut = "Ctrl+B"
         END CREATE
         CREATE MnuLset AS QMENUITEM
            Caption = "Left Justify"
            OnClick = MnuLSet_Click
            ShortCut = "shift+ctrl+L"
         END CREATE
         CREATE MnuCset AS QMENUITEM
            Caption = "Center"
            OnClick = MnuCSet_Click
            ShortCut = "shift+ctrl+M"
         END CREATE
         CREATE MnuRset AS QMENUITEM
            Caption = "Right Justify"
            OnClick = MnuRSet_Click
            ShortCut = "shift+ctrl+R"
         END CREATE
         CREATE line3 AS QMENUITEM
            Caption = "-"
         END CREATE
         CREATE MnuSwpCol AS QMENUITEM
            Caption = "SwapCols"
            OnClick = MnuSwpCol_Click
         END CREATE
         CREATE line4 AS QMENUITEM
            Caption = "-"
         END CREATE
         CREATE Undo AS QMENUITEM
            Caption = "Undo"
            OnClick = MnuUndo_Click
            ShortCut = "Ctrl+Z"
         END CREATE
         CREATE Redo AS QMENUITEM
            Caption = "Redo"
            OnClick = MnuRedo_Click
            ShortCut = "Ctrl+Y"
         END CREATE
      END CREATE
      CREATE HelpItem AS QMENUITEM
         Caption = "&?"
         CREATE AboutItem AS QMENUITEM
            Caption = "&About"
            OnClick = AboutItemOnClick
            ShortCut = "^a"
         END CREATE
      END CREATE
   END CREATE
   CREATE Panel AS QPANEL
      BevelInner = 2
      BevelOuter = 1
      Align = alTop
      Height = 30
      CREATE CEdit AS QEDIT
         Align = alLeft
         Width = 250
         OnKeyPress = CEditKeyPress
      END CREATE
   END CREATE
   CREATE Grid AS QSTRINGGRID
      CREATE PupMenu AS QPOPUPMENU
         CREATE PMnuEdit AS QMENUITEM
            Caption = "Edit Current Cell"
            OnClick = MnuEdit_Click
         END CREATE
         CREATE PMnuCopy AS QMENUITEM
            Caption = "Copy"
            OnClick = MnuCopy_Click
            ShortCut = "Ctrl+C"
         END CREATE
         CREATE PMnuPaste AS QMENUITEM
            Caption = "Paste"
            OnClick = MnuPaste_Click
            ShortCut = "Ctrl+V"
         END CREATE
         CREATE PMnuFColor AS QMENUITEM
            Caption = "Foreground Color"
            OnClick = MnuFColor_Click
            ShortCut = "Ctrl+F"
         END CREATE
         CREATE PMnuBColor AS QMENUITEM
            Caption = "Backgroundcolor"
            OnClick = MnuBColor_Click
            ShortCut = "Ctrl+B"
         END CREATE
         CREATE PMnuLset AS QMENUITEM
            Caption = "Left Justify"
            OnClick = MnuLSet_Click
            ShortCut = "shift+ctrl+L"
         END CREATE
         CREATE PMnuCset AS QMENUITEM
            Caption = "Center"
            OnClick = MnuCSet_Click
            ShortCut = "shift+ctrl+M"
         END CREATE
         CREATE PMnuRset AS QMENUITEM
            Caption = "Right Justify"
            OnClick = MnuRSet_Click
            ShortCut = "shift+ctrl+R"
         END CREATE
      END CREATE
      Font = MyFont
      Left = 0
      Top = 0
      Align = alClient
      ColCount = 10
      RowCount = 150
      FixedColor = &HFFD5C0
      Color = clLYellow
      GridLineWidth = 1
      DefaultColWidth = 125
      DefaultRowHeight = 75
      AddOptions(goRangeSelect)
      AddOptions(goColSizing)
      OnSelectCell = GridOnSelectCell
      OnDrawCell = GridOnDrawcell
      OnKeyPress = GridKeyPress
      OnKeyDown = GridKeyDown
   END CREATE
   CREATE Stbar AS QSTATUSBAR
      AddPanels "ColStart" , "RowStart" , "ColEnd" , "RowEnd" , "Undo Level " , "Redo Level " , "Note"
      Panel(0).Width = 100
      Panel(1).Width = 100
      Panel(2).Width = 100
      Panel(3).Width = 100
      Panel(4).Width = 100
      Panel(5).Width = 100
   END CREATE
END CREATE

DIM ClDlg AS QCOLORDIALOG
DIM D AS QDEBUG

'global vars

TYPE Record
   'Text AS STRING * 255
   'Col AS INTEGER
   'Row AS INTEGER
   'State AS INTEGER
   FCol AS LONG
   BCol AS LONG
   fStyle AS LONG
END TYPE
DIM MyRec AS Record

'For range selection
DIM RowStart AS INTEGER  '
DIM RowEnd AS INTEGER  '==> Range
DIM Colstart AS INTEGER  '
DIM ColEnd AS INTEGER  '

DIM CurRow AS INTEGER  '==> Active cell
DIM CurCol AS INTEGER  '

'Instead to use different single arrays it could be simpler an array of structures
'there is the problem of excessive memory consumption (I read somewhere that it is a RQ bug)

'to save all the format data, is necessary to bind array data, first text and then format style.
'to do this we need a structure and use the WriteUDT and ReatUDT QFileStram method.

DIM GridText(0 TO Grid.ColCount - 1 , 0 TO Grid.RowCount - 1) AS STRING
DIM FColCella(0 TO Grid.ColCount - 1 , 0 TO Grid.RowCount - 1) AS LONG
DIM BColCella(0 TO Grid.ColCount - 1 , 0 TO Grid.RowCount - 1) AS LONG
DIM AlignCella(0 TO Grid.ColCount - 1 , 0 TO Grid.RowCount - 1) AS LONG
'DIM Range(0 TO Grid.ColCount - 1 , 0 TO Grid.RowCount - 1) AS INTEGER

DIM hDC AS LONG  'for drawtext
DIM ver AS INTEGER  'for range lock/unlock
DIM mem AS QMEMORYSTREAM  'for range selection

'undo/redo
DIM Ulst(NUM_LEVEL_UNDO) AS QSTRINGLIST
DIM Uidx AS SHORT
DIM Rlst(NUM_LEVEL_UNDO) AS QSTRINGLIST
DIM Ridx AS SHORT

'register your own ClipBoard format
CONST MyClipboardFormatStr = "MyData"
DIM MyClpFormat AS LONG

MyClpFormat = RegisterClipboardFormat("MyData")

DIM OldStringGridWndProc AS LONG
OldStringGridWndProc = SetWindowLong(Grid.Handle , GWL_WNDPROC , CODEPTR(StringGridWndProc))

'minimize to taskbar correctly
SetWindowLong(Form.Handle , - 8 , 0)
SetWindowLong(Application.Handle , - 8 , Form.Handle)

'run application
Form.ShowModal

'--- New  WinProc StringGrid ---------------
FUNCTION StringGridWndProc(hWnd AS LONG , uMsg AS LONG , wParam AS LONG , lParam AS LONG) AS LONG
   Result = CallWindowProc(OldStringGridWndProc , hWnd , uMsg , wParam , lParam)

   SELECT CASE uMsg
      CASE WM_MOUSEWHEEL
         IF wParam > 0 THEN
            IF Grid.Row > 1 THEN
               Grid.Row = Grid.Row - 1
            END IF
         ELSE
            Grid.Row = Grid.Row + 1
         END IF
      CASE WM_LBUTTONUP
         RangeSel
   END SELECT

END FUNCTION

SUB print_stat
   Stbar.Panel(0).Caption = "ColStart: " + STR$(Colstart)
   Stbar.Panel(1).Caption = "RowStart: " + STR$(RowStart)
   Stbar.Panel(2).Caption = "ColEnd: " + STR$(ColEnd)
   Stbar.Panel(3).Caption = "RowEnd: " + STR$(RowEnd)
   Stbar.Panel(4).Caption = "Undo Level " + STR$(Uidx + 1)
   Stbar.Panel(5).Caption = "Redo Level " + STR$(Ridx + 1)
END SUB

'the core :-)
'according to the first and last cell saved and the active cell we could find the range.
'I decided that the first cell is the upper left and the last the bottom right.
SUB RangeSel
   DEFINT x , y  'first cell in mem obj
   DEFINT k , h  'last cell in mem obj

   ver = 1  'lock
   Grid.Repaint

   'read first col/row repainted
   mem.Position = 0
   x = mem.ReadNum(4)
   y = mem.ReadNum(4)

   'read last col/row repainted
   mem.Position = mem.Size - 8
   k = mem.ReadNum(4)
   h = mem.ReadNum(4)

   IF x = CurCol THEN
      Colstart = CurCol
      ColEnd = k
   END IF
   IF x > CurCol AND k > x THEN
      Colstart = CurCol
      ColEnd = k
   END IF
   IF x < k AND k < CurCol THEN
      Colstart = x
      ColEnd = CurCol
   END IF
   IF k = CurCol THEN
      Colstart = x
      ColEnd = CurCol
   END IF

   IF y = CurRow THEN
      RowStart = CurRow
      RowEnd = h
   END IF
   IF y > CurCol AND h > y THEN
      RowStart = CurRow
      RowEnd = h
   END IF
   IF y < h AND h < CurRow THEN
      RowStart = y
      RowEnd = CurRow
   END IF
   IF h = CurRow THEN
      RowStart = y
      RowEnd = CurRow
   END IF

   ver = 0  'reset lock
   print_stat

END SUB

SUB Initialize
   DEFINT k

   hDC = GetDC(Grid.Handle)
   SetBkMode(hDC , Transparent)
   selectobject(hDC , MyFont.Handle)

   Uidx = 0
   CurCol = 1
   CurRow = 1
   Grid.RowHeights(0) = 35
   Grid.ColWidths(0) = 40
   FOR k = 1 TO Grid.ColCount - 1
      AlignCella(k , 0) = 2  'center align
      GridText(k , 0) = "Col" + STR$(k)
   NEXT
   'BColCella(0 , 0) = clWhite
   FOR k = 1 TO Grid.RowCount - 1
      AlignCella(0 , k) = 3  'right align
      GridText(0 , k) = STR$(k)
      'BColCella(0 , k) = clLime
   NEXT

   'Ulstw.WriteNum(17,4)
   'Ulstw.close
   'd.print Ulstw.pointer

   'ClDlg.Colors(9) = clLYellow
   Setfocus(Grid.Handle)
END SUB

SUB Quit
   ReleaseDC(Grid.Handle , hDC)
   Application.Terminate
END SUB

SUB GridOnSelectCell(Col% , Row% , CanSelect% , Sender AS QSTRINGGRID)
   'reset mem obj
   mem.Position = 0
   mem.Size = 0
   mem.Close
   'set current cell
   CurCol = Col%
   CurRow = Row%
   'show cell text in edit control
   CEdit.Text = GridText(Col% , Row%)
END SUB

'all work here
SUB GridOnDrawcell(Col% , Row% , State% , Rect AS QRECT , Sender AS QSTRINGGRID)
   DEFINT txtposx , txtposy
   DEFINT k , h
   DEFLNG col , ccol
   DEFLNG fform

   DIM rct AS RECT
   rct.Top = Rect.Top
   rct.Left = rect.Left
   rct.right = rect.right
   rct.bottom = Rect.bottom

   '
   WITH Grid
      '
      'IF Row% = 0 OR col% = 0 THEN EXIT SUB
      'background color
      IF BColCella(Col% , Row%) > 0 THEN
         col = BColCella(Col% , Row%)
         sender.FillRect(Rect.Left + 1 , Rect.Top + 1 , Rect.Left + .ColWidths(Col%) - 1 , _
            Rect.Top + .RowHeights(Row%) - 1 , col)
         'ELSE
         'col=clLYellow
         'BColCella(Col% , Row%)=col
      END IF
      ccol = clLGray
      IF BColCella(Col% , Row%) THEN ccol = col AND &HDDDDDD

      'highlight selected cells and range
      IF State% = 1 THEN  '&hE1D2C9
         IF ver = 1 THEN
            mem.WriteNum(Col% , 4)
            mem.WriteNum(Row% , 4)
            'd.print "Col ",col%," Row ",row%
         END IF
         'Range(Col% , Row%) = 1

         Grid.FillRect(Rect.Left , Rect.Top , Rect.Left + Grid.ColWidths(Col%) , Rect.Top + Grid.RowHeights(Row%) , ccol)
         Sender.Rectangle(Rect.Left , Rect.Top , _
            Rect.Left + .ColWidths(Col%) , Rect.Top + .RowHeights(Row%) , clBlack)
      END IF

      'foreground color
      IF FColCella(Col% , Row%) > 0 THEN
         col = FColCella(Col% , Row%)
      ELSE
         col = 0
      END IF

      'write and align text.
      'txtposy = 2
      SELECT CASE AlignCella(Col% , Row%)
         CASE 1
            fform = DT_LEFT
            'txtposx = 2
         CASE 2
            fform = DT_CENTER
            'txtposx = ((Rect.right - Rect.Left) \ 2) - (sender.TextWidth(GridText(Col% , Row%)) \ 2)
         CASE 3
            fform = DT_RIGHT
         CASE ELSE
            fform = DT_LEFT
            'txtposx = Rect.right - sender.TextWidth(GridText(Col% , Row%)) - Rect.Left - 1
      END SELECT
      'uncomment the next line and comment the other to switch beetween the text write methods
      'sender.TextOut(Rect.Left + txtposx , Rect.Top + txtposy , GridText(Col% , Row%) , col , - 1)
      StringOut(Rect.Left , Rect.Top , LTRIM$(RTRIM$(GridText(Col% , Row%))) , col , rct , fform)
   END WITH

END SUB

'foreground color menu
SUB MnuFColor_Click
   DEFINT risp

   ClDlg.Caption = "Foreground color"
   ClDlg.Color = FColCella(CurCol , CurRow)
   'ClDlg.Colors(1)=BColCella(CurCol , CurRow)
   risp = ClDlg.Execute
   IF risp = TRUE THEN Set_format(0)

END SUB

'background color menu
SUB MnuBColor_Click
   DEFINT risp

   ClDlg.Caption = "Background color"
   ClDlg.Color = BColCella(CurCol , CurRow)
   'if BColCella(CurCol , CurRow)<> clLYellow then ClDlg.Colors(1)=BColCella(CurCol , CurRow)
   risp = ClDlg.Execute
   IF risp = TRUE THEN Set_format(1)
END SUB

SUB MnuLSet_Click
   Set_format(2)
END SUB

SUB MnuCSet_Click
   Set_format(3)
END SUB

SUB MnuRSet_Click
   Set_format(4)
END SUB

SUB MnuEdit_Click
   GridKeyPress(13)
END SUB

'Clipboard custom format
'surfig on internet I've found several examples, all in Delphi.
'here is my translation to RQ.
'the next step is to recognize a user range select(more then one cell)
'and copy it to another position. If a not equal range is selected for the copy, then error
'so you can select or a single cell, or a equal range.
'in the MnuPaste_Click SUB we also have to manege this difference.

SUB MnuCopy_Click
   DIM dh AS LONG  'memory handle
   DIM p AS LONG  'pointer to memory block
   DIM wRec AS Record  '
   DIM cpmem AS QMEMORYSTREAM
   DIM tmpstr AS STRING * 64  'cell text
   DEFINT k , h
   DEFLNG totcells , totbyte

   RangeSel
   'copy data to QMEMORYSTREAM
   totcells = (ColEnd - Colstart + 1) * (RowEnd - RowStart + 1)
   totbyte = (totcells * SIZEOF(wRec)) + (totcells * 64) + 12  'total size of bytes to copy

   cpmem.Position = 0
   cpmem.Close

   cpmem.WriteNum(totbyte , 4) 'total byte
   cpmem.WriteNum(ColEnd - Colstart + 1 , 4) 'cols num
   cpmem.WriteNum(RowEnd - RowStart + 1 , 4) 'rows num
   FOR k = Colstart TO ColEnd
      FOR h = RowStart TO RowEnd
         tmpstr = GridText(k , h)
         wRec.fcol = FColCella(k , h)
         wRec.bcol = BColCella(k , h)
         wRec.fStyle = AlignCella(k , h)
         cpmem.writeUDT(wRec)
         cpmem.WriteStr(tmpstr , 64)
      NEXT
   NEXT

   'allocate memory for item
   'dh = GlobalAlloc(GMEM_FIXED OR GMEM_ZEROINIT , (SIZEOF(wRec)))
   dh = GlobalAlloc(GMEM_FIXED OR GMEM_ZEROINIT , cpmem.Size)

   'Lock the allocated memory
   p = GlobalLock(dh)
   'copy UDT to the memory block
   'MEMCPY(p , UDTPTR(wRec) , SIZEOF(wRec))
   MEMCPY(p , cpmem.pointer , cpmem.Size)

   Clipboard.Open
   Clipboard.Clear

	Clipboard.SetAsText(GridText(CurCol , CurRow))
   Clipboard.SetAsHandle(MyClpFormat , dh)

   Clipboard.Close
   'unlock the allocate memory. But don't free it, it will be used by the clipboard
   GlobalUnlock(dh)
END SUB

SUB MnuPaste_Click
   DEFINT k , h
   DIM dh AS LONG
   DIM p AS LONG
   DIM wRec AS Record
   DIM psmem AS QMEMORYSTREAM
   DEFLNG nb , nc , nr
   DIM tmpstr AS STRING * 64

   Clipboard.Open

   'handle of allocated memory
	GridText(CurCol , CurRow) = ClipBoard.GetAsText(10)

   dh = Clipboard.GetAsHandle(MyClpFormat)
   'lock it
   p = GlobalLock(dh)

   'first read byte, cols and rows
   psmem.Close
   psmem.MemCopyFrom(p , 12)
   psmem.Position = 0
   nb = psmem.ReadNum(4)
   nc = psmem.ReadNum(4)
   nr = psmem.ReadNum(4)

   'after read copied data
   psmem.Close
   'copy back memory block to the QMEM
   psmem.MemCopyFrom(p , nb)
   'MEMCPY(UDTPTR(wRec) , p , SIZEOF(wRec))
   psmem.Position = 12

   RangeSel  'paste range
   AddToUndo(Colstart , RowStart , ColEnd , RowEnd)
   'if the copy range was 1 cell
   IF nc = 1 AND nr = 1 THEN
      psmem.readudt(wRec)
      tmpstr = psmem.ReadStr(64)
      FOR k = Colstart TO ColEnd
         FOR h = RowStart TO RowEnd
            GridText(k , h) = tmpstr
            FColCella(k , h) = wRec.fcol
            BColCella(k , h) = wRec.bcol
            AlignCella(k , h) = wRec.fStyle
         NEXT
      NEXT
   ELSE  'it was more then 1 cell
      IF ((ColEnd - Colstart + 1) * (RowEnd - RowStart + 1)) / (nc * nr) <> 1 THEN
         MESSAGEBOX("Range Selection not valid" , "WS" , &H30)
         EXIT SUB
      END IF
      'copy QMEM to the range
      FOR k = Colstart TO ColEnd
         FOR h = RowStart TO RowEnd
            psmem.readudt(wRec)
            tmpstr = psmem.ReadStr(64)
            GridText(k , h) = tmpstr
            FColCella(k , h) = wRec.fcol
            BColCella(k , h) = wRec.bcol
            AlignCella(k , h) = wRec.fStyle
         NEXT
      NEXT
   END IF
   Clipboard.Close
   'and unlock the pointer, but don't free it. This will be done by the clipboard itself,
   'if necessary
   GlobalUnlock(dh)
   Grid.Repaint
END SUB

SUB MnuSwpCol_Click
   DEFINT k

   Colstart = CurCol
   ColEnd = CurCol + 1
   RowStart = 1
   RowEnd = Grid.RowCount - 1
   AddToUndo(Colstart , RowStart , ColEnd , RowEnd)
   IF CurCol < Grid.ColCount - 1 THEN
      FOR k = 1 TO Grid.RowCount
         SWAP GridText(CurCol , k) , GridText(CurCol + 1 , k)
         SWAP FColCella(CurCol , k) , FColCella(CurCol + 1 , k)
         SWAP BColCella(CurCol , k) , BColCella(CurCol + 1 , k)
         SWAP AlignCella(CurCol , k) , AlignCella(CurCol + 1 , k)
      NEXT
   END IF
   FOR k = 1 TO Grid.ColCount - 1
      AlignCella(k , 0) = 2  'center align
      GridText(k , 0) = "Col" + STR$(k)
   NEXT

   Grid.Repaint
END SUB

SUB AddToRedo(cs% , rs% , ce% , re%)
   DEFINT k , h

   IF Ridx = NUM_LEVEL_UNDO + 1 THEN
      Ridx --
      FOR k = 0 TO NUM_LEVEL_UNDO - 1
         Rlst(k).Clear  'reset list
         Rlst(k).AddList(Rlst(k + 1)) 'copy all of list
      NEXT k
   END IF

   'save range
   Rlst(Ridx).Clear
   Rlst(Ridx).AddItems(STR$(cs%))
   Rlst(Ridx).AddItems(STR$(rs%))
   Rlst(Ridx).AddItems(STR$(ce%))
   Rlst(Ridx).AddItems(STR$(re%))

   FOR k = cs% TO ce%
      FOR h = rs% TO re%
         Rlst(Ridx).AddItems(STR$(FColCella(k , h)))
         Rlst(Ridx).AddItems(STR$(BColCella(k , h)))
         Rlst(Ridx).AddItems(STR$(AlignCella(k , h)))
         Rlst(Ridx).AddItems(GridText(k , h))
      NEXT
   NEXT

   Ridx ++
   print_stat
END SUB

SUB AddToUndo(cs% , rs% , ce% , re%)
   DEFINT k , h

   'if the queue is full shift one level to the previous
   IF Uidx = NUM_LEVEL_UNDO + 1 THEN
      Uidx --
      FOR k = 0 TO NUM_LEVEL_UNDO - 1
         Ulst(k).Clear  'reset list
         Ulst(k).AddList(Ulst(k + 1)) 'copy all of list
      NEXT k
   END IF
   'save data
   'first the range
   Ulst(Uidx).Clear
   Ulst(Uidx).AddItems(STR$(cs%))
   Ulst(Uidx).AddItems(STR$(rs%))
   Ulst(Uidx).AddItems(STR$(ce%))
   Ulst(Uidx).AddItems(STR$(re%))
   'after the data
   FOR k = cs% TO ce%
      FOR h = rs% TO re%
         Ulst(Uidx).AddItems(STR$(FColCella(k , h)))
         Ulst(Uidx).AddItems(STR$(BColCella(k , h)))
         Ulst(Uidx).AddItems(STR$(AlignCella(k , h)))
         Ulst(Uidx).AddItems(GridText(k , h))
      NEXT
   NEXT
   Uidx ++
   print_stat

END SUB

SUB GridKeyDown(Key AS WORD , Shift AS INTEGER)
   IF Key = 46 THEN
      Set_format(5)
   END IF
END SUB

SUB GridKeyPress(Key AS BYTE)
   IF key = 13 THEN
      setfocus(CEdit.Handle)
   END IF
END SUB

SUB CEditKeyPress(Key AS BYTE)
   IF key = 13 THEN
      RangeSel
      AddToUndo(Colstart , RowStart , ColEnd , RowEnd)
      GridText(CurCol , CurRow) = CEdit.Text
      setfocus(Grid.Handle)
   END IF
END SUB

'put here other format option
SUB Set_format(wform AS INTEGER)
   DEFINT k , h

   RangeSel
   AddToUndo(Colstart , RowStart , ColEnd , RowEnd)
   FOR k = Colstart TO ColEnd
      FOR h = RowStart TO RowEnd
         SELECT CASE wform
            CASE 0
               FColCella(k , h) = ClDlg.Color
            CASE 1
               BColCella(k , h) = ClDlg.Color
            CASE 2
               AlignCella(k , h) = 1
            CASE 3
               AlignCella(k , h) = 2
            CASE 4
               AlignCella(k , h) = 3
            CASE 5
               GridText(k , h) = ""
         END SELECT
      NEXT
   NEXT
   Grid.Repaint

END SUB

SUB StringOut(x1% , y1% , text$ , col& , wrect AS RECT , format&)
   SetTextColor(hDC , col&)
   DrawText(hDC , text$ , LEN(text$) , wrect , format& OR DT_WORDBREAK) 'OR DT_VCENTER OR DT_NOCLIP   )
   'TextOut(hDC , x1% , y1% , text$ , LEN(text$))
END SUB

SUB ClearUndoRedo
   DEFINT k

   FOR k = 0 TO NUM_LEVEL_UNDO - 1
      Rlst(k).Clear
      Ulst(k).Clear
   NEXT k
   Uidx = 0
   Ridx = 0
   print_stat

END SUB

SUB SaveItemOnClick
   DEFINT k , h
   DIM file AS QFILESTREAM

   file.Open("rangesel.txt" , fmCreate)
   file.WriteNum(Grid.RowCount , 4)
   FOR h = 1 TO Grid.RowCount - 1
      FOR k = 1 TO Grid.ColCount - 1
         MyRec.fcol = FColCella(k , h)
         MyRec.bcol = BColCella(k , h)
         MyRec.fstyle = AlignCella(k , h)
         file.WriteUDT(MyRec)
         file.WriteLine GridText(k , h)
      NEXT
   NEXT
   ClearUndoRedo
   file.Close
END SUB

SUB OpenItemOnClick
   DEFINT k , h
   DIM file AS QFILESTREAM

   file.Open("rangesel.txt" , fmOpenRead)
   Grid.RowCount = file.ReadNum(Num_LONG)
   FOR h = 1 TO Grid.RowCount - 1
      FOR k = 1 TO Grid.ColCount - 1
         file.ReadUDT(MyRec)
         FColCella(k , h) = MyRec.fcol
         BColCella(k , h) = MyRec.bcol
         AlignCella(k , h) = MyRec.fstyle
         GridText(k , h) = file.ReadLine
      NEXT
   NEXT
   ClearUndoRedo
   file.Close
   Grid.Repaint
END SUB

SUB AboutItemOnClick
   MESSAGEBOX("Range Selection in a QSTRINGGRID control" & CHR$(13) & CHR$(13) & CHR$(9) & "Rel. 0.15" , "WS" , &H40)
END SUB

SUB MnuRedo_Click
   DEFINT cs , rs , ce , re , k , h , kk

   IF Ridx = 0 THEN
      MESSAGEBOX("No more level" , "REDO" , 0)
      EXIT SUB
   END IF

   Ridx --
   cs = VAL(Rlst(Ridx).Item(0))
   rs = VAL(Rlst(Ridx).Item(1))
   ce = VAL(Rlst(Ridx).Item(2))
   re = VAL(Rlst(Ridx).Item(3))
   AddToUndo(cs , rs , ce , re)

   kk = 4
   FOR k = cs TO ce
      FOR h = rs TO re
         FColCella(k , h) = VAL(Rlst(Ridx).Item(kk))
         kk ++
         BColCella(k , h) = VAL(Rlst(Ridx).Item(kk))
         kk ++
         AlignCella(k , h) = VAL(Rlst(Ridx).Item(kk))
         kk ++
         GridText(k , h) = Rlst(Ridx).Item(kk)
         kk ++
      NEXT
   NEXT

   print_stat
   Grid.Repaint

END SUB

SUB MnuUndo_Click
   DEFINT cs , rs , ce , re , k , h , kk

   IF Uidx = 0 THEN
      MESSAGEBOX("No more level" , "UNDO" , 0)
      EXIT SUB
   END IF

   Uidx --
   cs = VAL(Ulst(Uidx).Item(0))
   rs = VAL(Ulst(Uidx).Item(1))
   ce = VAL(Ulst(Uidx).Item(2))
   re = VAL(Ulst(Uidx).Item(3))
   'd.print (cs,rs,ce,re)
   AddToRedo(cs , rs , ce , re)

   kk = 4
   FOR k = cs TO ce
      FOR h = rs TO re
         FColCella(k , h) = VAL(Ulst(Uidx).Item(kk))
         kk ++
         BColCella(k , h) = VAL(Ulst(Uidx).Item(kk))
         kk ++
         AlignCella(k , h) = VAL(Ulst(Uidx).Item(kk))
         kk ++
         GridText(k , h) = Ulst(Uidx).Item(kk)
         kk ++
      NEXT
   NEXT

   print_stat
   Grid.Repaint

END SUB
